-- Copyright (C) 2020  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and any partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details, at
-- https://fpgasoftware.intel.com/eula.

-- ***************************************************************************
-- This file contains a Vhdl test bench template that is freely editable to   
-- suit user's needs .Comments are provided in each section to help the user  
-- fill out necessary details.                                                
-- ***************************************************************************
-- Generated on "02/05/2025 22:36:10"
                                                            
-- Vhdl Test Bench template for design  :  Add_Accum_BCD_2digit
-- 
-- Simulation tool : ModelSim-Altera (VHDL)
-- 

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY Add_Accum_BCD_2digit_vhd_tst IS
END Add_Accum_BCD_2digit_vhd_tst;

ARCHITECTURE Add_Accum_BCD_2digit_arch OF Add_Accum_BCD_2digit_vhd_tst IS
-- constants                                                 
-- signals                                                   
SIGNAL CD_L : STD_LOGIC;
SIGNAL Din : STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL DONE : STD_LOGIC;
SIGNAL LT_L : STD_LOGIC_VECTOR(6 DOWNTO 0);
SIGNAL LU_L : STD_LOGIC_VECTOR(6 DOWNTO 0);
SIGNAL OSC_CLK_in : STD_LOGIC;
SIGNAL START_L : STD_LOGIC;
SIGNAL STOP_L : STD_LOGIC;

COMPONENT Add_Accum_BCD_2digit
	PORT (
	CD_L : IN STD_LOGIC;
	Din : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
	DONE : OUT STD_LOGIC;
	LT_L : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);
	LU_L : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);
	OSC_CLK_in : IN STD_LOGIC;
	START_L : IN STD_LOGIC;
	STOP_L : IN STD_LOGIC
	);
END COMPONENT;

   -- Use the clock period which suits your application
   -- Clock period definitions, in this case a frequency of 1 MHz
   constant CLK_period : time := 1 us;
 

BEGIN
	i1 : Add_Accum_BCD_2digit
	PORT MAP (
-- list connections between master ports and signals
	CD_L => CD_L,
	Din => Din,
	DONE => DONE,
	LT_L => LT_L,
	LU_L => LU_L,
	OSC_CLK_in => OSC_CLK_in,
	START_L => START_L,
	STOP_L => STOP_L
	);
	
	
-- Clock process definitions                                                  
-- Let's use all the simulation time relative to the "CLK_period" constant
-- In this way it's easy to run simulations at different time scales. 
-- Only a constant needs to be modified. 
-- Start and wait for some time

 clk_signal : PROCESS                                              
	BEGIN                                                         
    	OSC_CLK_in <= '0';			  
		wait for CLK_period/2;
		
		OSC_CLK_in <= '1';
		wait for CLK_period/2;

	END PROCESS clk_signal ;

	
   -- Stimulus process to be copied at the test bench file in the corresponding section:  
   stimulus_signals: process
	begin		
		wait for CLK_period*6.23;	
		CD_L <= '1';	
		START_L	<= '1';
		STOP_L 	<= '1';
		Din		<= "0100";		
		wait for CLK_period*3.18;	

		CD_L <= '0';	-- asynchronous reset active-low pulse
		wait for CLK_period*2.18;	

		CD_L <= '1';	
		wait for CLK_period*4.28;	
		
----------------------------------------------------------------------		
		START_L <= '0';	-- start operation pulse
		wait for CLK_period*75.18;	

		START_L <= '1';	
		wait for CLK_period*204.28;	-- machine operating .....
----------------------------------------------------------------------

		
		START_L <= '0';	-- go back to idle pulse 
		wait for CLK_period*102.78;	

		START_L <= '1';	
		wait for CLK_period*323.28;	-- machine idle .....
----------------------------------------------------------------------	
		Din		<= "0111";		
	
		START_L <= '0';	-- start operation pulse
		wait for CLK_period*230.18;	

		START_L <= '1';	
		wait for CLK_period*1100.28;	
					-- machine operating, it will stop when overflow 
----------------------------------------------------------------------


----------------------------------------------------------------------	
		Din		<= "1001";		
	
		START_L <= '0';	-- start operation pulse
		wait for CLK_period*200.18;	

		START_L <= '1';	
		wait for CLK_period*1245.28;	-- machine operating .... 
----------------------------------------------------------------------

----------------------------------------------------------------------	
		
		STOP_L <= '0';	-- stop operation pulse
		wait for CLK_period*98.33;	

		STOP_L <= '1';	
		wait for CLK_period*200.28;	-- machine idle .... 
----------------------------------------------------------------------

----------------------------------------------------------------------	
		Din		<= "0011";		
	
		START_L <= '0';	-- start operation pulse
		wait for CLK_period*65.18;	

		START_L <= '1';	
		wait for CLK_period*304.28;	
					-- machine operating, it will stop when overflow 
----------------------------------------------------------------------

----------------------------------------------------------------------	
		Din		<= "0010";		
		wait for CLK_period*65.18;	

		Din		<= "0110";		
		wait for CLK_period*105.18;		
---------------------------------------------------------------------	
		
		STOP_L <= '0';	-- stop operation pulse
		wait for CLK_period*98.33;	

		STOP_L <= '1';	
		wait for CLK_period*200.28;	-- machine idle .... 
----------------------------------------------------------------------

      wait;
		
   end process stimulus_signals ;


                                     
END Add_Accum_BCD_2digit_arch;
