--------------------------------------------------------------------------------
-- Project P8  - CSD 
-- Dedicated processors 
-- https://digsys.upc.edu/csd/P08/P8.html
---------------------------------------------------
-- Example of plan B combinational circuit 
-- Truth table for the 1-digit BCD adapter: 
-- 		If the 4-bit input is a valid BCD code ---> Y <-- D
--		else output = "0000" 
-- Tutorial project location:
-- https://digsys.upc.edu/csd/P08/Add_Accum/Add_Accum.html
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY BCD_Adapter IS
	PORT (
		D	:	IN	STD_LOGIC_VECTOR(3 downto 0);
		Y	:	OUT	STD_LOGIC_VECTOR(3 downto 0)
	);
END BCD_Adapter;

architecture Truth_table_description of BCD_Adapter is
BEGIN

Y <= D when D < "1010" else "0000";

END Truth_table_description;
