--------------------------------------------------------------------------------
-- Project P8  - CSD 
-- Dedicated processors 
-- https://digsys.upc.edu/csd/P08/P8.html
---------------------------------------------------
-- Example of plan B combinational circuit 
-- Truth table for the 1-digit BCD adapter: 
-- 		If the 4-bit input is a valid BCD code ---> Y <-- D
--		else output = "0000" 
-- Tutorial project location:
-- https://digsys.upc.edu/csd/P08/Add_Accum/Add_Accum.html
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY BCD_Adapter IS
	PORT (
		D	:	IN	STD_LOGIC_VECTOR(3 downto 0);
		Y	:	OUT	STD_LOGIC_VECTOR(3 downto 0)
	);
END BCD_Adapter;

architecture Truth_table_description of BCD_Adapter is
BEGIN
	PROCESS (D)  
		BEGIN
				CASE D IS    		
					WHEN "0000" =>       		
						Y <= "0000";
					WHEN "0001" =>       		
						Y <= "0001";
					WHEN "0010" =>       		
						Y <= "0010";
					WHEN "0011" =>       		
						Y <= "0011";
					WHEN "0100" =>       		
						Y <= "0100";
					WHEN "0101" =>       		
						Y <= "0101";
					WHEN "0110" =>       		
						Y <= "0110";
					WHEN "0111" =>       		
						Y <= "0111";
					WHEN "1000" =>       		
						Y <= "1000";
					WHEN "1001" =>       		
						Y <= "1001";			
					WHEN Others =>  -- the remaining invalid six codes    
						Y <= "0000";
				END CASE;
			
	END PROCESS;
		 		   	 		 		   	   
END Truth_table_description;