--------------------------------------------------------------------------------
-- Project P2 - CSD 
-- https://digsys.upc.edu
---------------------------------------------------
-- Example of chip design: Septuple multiplexer of 2 channels: Septuple_MUX_2
-- Plan B, behavioural --> truth table--> flowchart
---------------------------------------------------
-- Adapted from a similar project at: 
-- https://digsys.upc.edu/csd/P02/Dual_MUX_4_planB/Dual_MUX_4_planB.html
--------------------------------------------------------------------------------

LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Septuple_MUX_2 IS
	PORT (			
		Ch0, Ch1	: 	IN 	STD_LOGIC_VECTOR (6 downto 0);  
		S			:	IN 	STD_LOGIC;	
		E			: 	IN 	STD_LOGIC;
		Y			: 	OUT	STD_LOGIC_VECTOR (6 downto 0)
	  );
END Septuple_MUX_2;

architecture truth_table of Septuple_MUX_2 is

begin   
-- this algorithm defines the circuit's behaviour 
Y	<= 	Ch0 when (S ='0' and E = '1') else
		Ch1 when (S ='1' and E = '1') 
		else "0000000"; -- disable
end truth_table;